#ifndef _LPCPROG_H
#define _LPCPROG_H

#include <stdint.h>

typedef struct _chunk_t chunk_t;

struct _chunk_t
{
    chunk_t *next;

    uint32_t addr;
    int     datalen;
    char    *data;
};


typedef struct
{
    int      nchunks;
    chunk_t *chunks;

    uint32_t startaddr;
} objdata_t;

chunk_t *chunk_create(int chunksize);

struct sector
{
  int           id;
  uint32_t       addr, size;
};

struct device
{
  char          *partid;
  char          *description;
  int            numsectors;
  struct sector *sectors;

  uint32_t        ramaddr; // where can we upload data?
  uint32_t        ramsize; // how much data can we upload at a time?
};

extern struct device devices[];

#endif
